//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.Net;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// [gQƂŃ`[i[̏Ԃi[ReiC^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("8901547A-020A-41c2-961F-6BD20EDE329A")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IRemoteTunerStatus
	{
		/// <summary>
		/// `[i[擾܂B
		/// </summary>
		/// <remarks>`[i[BonSDK̃`[i[NXłB</remarks>
		[Category("General")]
		[Description("Tuner name. (BonSDK tuner class name)")]
		string TunerName
		{
			get;
		}

		/// <summary>
		/// foCX擾܂B
		/// </summary>
		/// <remarks>foCX̓`[i[NX瓾ꂽ[U[ǉ\ȕłB</remarks>
		[Category("General")]
		[Description("Tuner device name.")]
		string DeviceName
		{
			get;
		}

		/// <summary>
		/// foCXID擾܂B
		/// </summary>
		/// <remarks>ނ̃`[i[݂ꍇɁAقȂlԂ܂B</remarks>
		[Category("General")]
		[Description("Tuner device ID.")]
		int DeviceID
		{
			get;
		}

		/// <summary>
		/// `[i[̃bNԂ擾܂B
		/// </summary>
		[Category("General")]
		[Description("Is tuner locked?")]
		bool IsLocked
		{
			get;
		}

		/// <summary>
		/// ݑIĂ`[jOXy[X擾܂B
		/// </summary>
		[Category("Tuning Space")]
		[Description("Current tuning space number.")]
		int TuningSpace
		{
			get;
		}

		/// <summary>
		/// ݑIĂ`l擾܂B
		/// </summary>
		[Category("Tuning Space")]
		[Description("Current channel number.")]
		int Channel
		{
			get;
		}

		/// <summary>
		/// J[hID擾܂B
		/// </summary>
		[Category("General")]
		[Description("CAS card ID.")]
		byte[] CardID
		{
			get;
		}

		/// <summary>
		/// J[hɑ΂EMMKp邩ǂ擾܂B
		/// </summary>
		[Category("Tuner Feature")]
		[Description("Enable CAS card EMM process.")]
		bool EnableEmmProcess
		{
			get;
		}

		/// <summary>
		/// `[i[ɐڑĂAeipLNBdL邩ǂ擾܂B
		/// </summary>
		[Category("Tuner Feature")]
		[Description("Enable tuner LNB power.")]
		bool EnableLnbPower
		{
			get;
		}

		/// <summary>
		/// `[i[ɐڑĂAeǐ݂̎Mx擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current tuning signal level.")]
		float SignalLevel
		{
			get;
		}

		/// <summary>
		/// ݎM̃Xg[̃lbg[NID擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current tuning network ID.")]
		int NetworkID
		{
			get;
		}

		/// <summary>
		/// ݎM̃Xg[̃lbg[N擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current tuning network name.")]
		string NetworkName
		{
			get;
		}

		/// <summary>
		/// ݎM̃Xg[̃gX|[gXg[ID擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current tuning transport stream ID.")]
		int TransportStreamID
		{
			get;
		}

		/// <summary>
		/// ݎM̃Xg[̊Jn擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current tuning stream start time.")]
		DateTime StreamTime
		{
			get;
		}

		/// <summary>
		/// XNȕԂ擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current CAS descrambling status.")]
		DescramblingStates DescramblingStatus
		{
			get;
		}

		/// <summary>
		/// ̃`[i[̃Xg[M邽߂URLQ擾܂B
		/// </summary>
		/// <remarks>C^[tFCX݂\邽߁AꂼURL܂܂܂B</remarks>
		[Category("Stream Service")]
		[Description("Stream service acceptable URLs.")]
		Uri[] StreamUrls
		{
			get;
		}

		/// <summary>
		/// ݂̃`[i[ɐڑĂXg[NCAg̃Gh|CgQ擾܂B
		/// </summary>
		/// <remarks>̏ŁAڑĂXg[NCAgo܂B</remarks>
		[Category("Stream Service")]
		[Description("Current stream clients.")]
		IPEndPoint[] ClientEndPoints
		{
			get;
		}
	}
}
