//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Runtime.InteropServices;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;

namespace Bon.Remoting
{
	/// <summary>
	/// NCAgŎgpoA[gQƂ擾NXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("0110D48F-A7D4-4ac2-A5D5-7B4681E87F16")]
	[ComDefaultInterface(typeof(IRemoteStreamService))]
	public sealed class RemoteStreamService : IRemoteStreamService
	{
		private HttpClientChannel channel_ = new HttpClientChannel();

		/// <summary>
		/// RXgN^łB
		/// </summary>
		public RemoteStreamService()
		{
			// [eBO`lL
			ChannelServices.RegisterChannel(channel_, false);
		}

		/// <summary>
		/// Dispose\bhłB
		/// </summary>
		public void Dispose()
		{
			if (channel_ != null)
			{
				ChannelServices.UnregisterChannel(channel_);
				channel_ = null;
			}
		}

		/// <summary>
		/// `[i[RNVURI擾܂B
		/// </summary>
		public static string TunerCollectionUri
		{
			get
			{
				return "TunerCollection.rem";
			}
		}

		/// <summary>
		/// R[_[URI擾܂B
		/// </summary>
		public static string RecorderUri
		{
			get
			{
				return "Recorder.rem";
			}
		}

		private T CreateRemoteReference<T>(Uri streamServiceBaseUrl, string uri)
		{
			if (streamServiceBaseUrl.AbsolutePath.EndsWith("/") == false)
			{
				return (T)Activator.GetObject(typeof(T), string.Format("{0}/{1}", streamServiceBaseUrl, uri));
			}
			else
			{
				return (T)Activator.GetObject(typeof(T), string.Format("{0}{1}", streamServiceBaseUrl, uri));
			}
		}

		/// <summary>
		/// `[i[RNVւ̃[gQƂ擾܂B
		/// </summary>
		/// <param name="streamServiceBaseUrl">Xg[T[rX̃x[XURL</param>
		/// <remarks>`[i[RNVւ̃[gQ</remarks>
		/// <remarks>x[XURL"http://localhost:26110/stream/"̂悤Ȍ`łB</remarks>
		public IRemoteTunerCollection GetTunerCollection(Uri streamServiceBaseUrl)
		{
			return CreateRemoteReference<IRemoteTunerCollection>(streamServiceBaseUrl, TunerCollectionUri);
		}

		/// <summary>
		/// R[_[ւ̃[gQƂ擾܂B
		/// </summary>
		/// <param name="streamServiceBaseUrl">Xg[T[rX̃x[XURL</param>
		/// <remarks>R[_[ւ̃[gQ</remarks>
		/// <remarks>x[XURL"http://localhost:26110/stream/"̂悤Ȍ`łB</remarks>
		public IRemoteRecorder GetRecorder(Uri streamServiceBaseUrl)
		{
			return CreateRemoteReference<IRemoteRecorder>(streamServiceBaseUrl, RecorderUri);
		}
	}
}
