//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.Net;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// [gQƂŃ`[i[̏Ԃi[ReiNXłB
	/// </summary>
	/// <remarks>̃NX̓VA\œǂݎpłB</remarks>
	[Serializable]
	[ComVisible(true)]
	[Guid("7BD7F1C3-D710-4930-BFE2-34DB6D2B9CB9")]
	[ComDefaultInterface(typeof(IRemoteTunerStatus))]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public sealed class RemoteTunerStatus : IRemoteTunerStatus
	{
		private readonly string tunerName_;
		private readonly string deviceName_;
		private readonly int deviceID_;
		private readonly bool locked_;
		private readonly int tuningSpace_ = -1;
		private readonly int channel_ = - 1;
		private readonly byte[] cardID_;
		private readonly bool enableEmmProcess_;
		private readonly bool enableLnbPower_;
		private readonly float signalLevel_;
		private readonly int networkID_;
		private readonly string networkName_;
		private readonly int transportStreamID_;
		private readonly DateTime streamTime_;
		private readonly DescramblingStates descramblingStatus_;
		private readonly Uri[] streamUrls_;
		private readonly IPEndPoint[] clientEndPoints_;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="tuner">̃`[i[C^[tFCX</param>
		/// <param name="streamUrls">Xg[URLQ</param>
		/// <param name="clientEndPoints">NCAgGh|CgQ</param>
		/// <remarks>Ŏw肳ꂽ݂EPGRs[Ċi[܂B</remarks>
		public RemoteTunerStatus(ITuner tuner, Uri[] streamUrls, IPEndPoint[] clientEndPoints)
		{
			tunerName_ = tuner.TunerName;
			deviceName_ = tuner.DeviceName;
			deviceID_ = tuner.DeviceID;
			locked_ = tuner.IsLocked;
			cardID_ = tuner.CardID;
			enableEmmProcess_ = tuner.EnableEmmProcess;
			enableLnbPower_ = tuner.EnableLnbPower;
			signalLevel_ = tuner.SignalLevel;
			networkID_ = tuner.NetworkID;
			networkName_ = tuner.NetworkName;
			transportStreamID_ = tuner.TransportStreamID;
			streamTime_ = tuner.StreamTime;
			descramblingStatus_ = tuner.DescramblingStatus;
			streamUrls_ = streamUrls;
			clientEndPoints_ = clientEndPoints;

			ISelectedChannel channel = tuner.GetChannel();
			tuningSpace_ = channel.TuningSpace;
			channel_ = channel.Channel;
		}

		/// <summary>
		/// `[i[擾܂B
		/// </summary>
		/// <remarks>`[i[BonSDK̃`[i[NXłB</remarks>
		[Category("General")]
		[Description("Tuner name. (BonSDK tuner class name)")]
		public string TunerName
		{
			get
			{
				return tunerName_;
			}
		}

		/// <summary>
		/// foCX擾܂B
		/// </summary>
		/// <remarks>foCX̓`[i[NX瓾ꂽ[U[ǉ\ȕłB</remarks>
		[Category("General")]
		[Description("Tuner device name.")]
		public string DeviceName
		{
			get
			{
				return deviceName_;
			}
		}

		/// <summary>
		/// foCXID擾܂B
		/// </summary>
		/// <remarks>ނ̃`[i[݂ꍇɁAقȂlԂ܂B</remarks>
		[Category("General")]
		[Description("Tuner device ID.")]
		public int DeviceID
		{
			get
			{
				return deviceID_;
			}
		}

		/// <summary>
		/// `[i[̃bNԂ擾܂B
		/// </summary>
		[Category("General")]
		[Description("Is tuner locked?")]
		public bool IsLocked
		{
			get
			{
				return locked_;
			}
		}

		/// <summary>
		/// ݑIĂ`[jOXy[X擾܂B
		/// </summary>
		[Category("Tuning Space")]
		[Description("Current tuning space number.")]
		public int TuningSpace
		{
			get
			{
				return tuningSpace_;
			}
		}

		/// <summary>
		/// ݑIĂ`l擾܂B
		/// </summary>
		[Category("Tuning Space")]
		[Description("Current channel number.")]
		public int Channel
		{
			get
			{
				return channel_;
			}
		}

		/// <summary>
		/// J[hID擾܂B
		/// </summary>
		[Category("General")]
		[Description("CAS card ID.")]
		public byte[] CardID
		{
			get
			{
				return cardID_;
			}
		}

		/// <summary>
		/// J[hɑ΂EMMKp邩ǂ擾܂B
		/// </summary>
		[Category("Tuner Feature")]
		[Description("Enable CAS card EMM process.")]
		public bool EnableEmmProcess
		{
			get
			{
				return enableEmmProcess_;
			}
		}

		/// <summary>
		/// `[i[ɐڑĂAeipLNBdL邩ǂ擾܂B
		/// </summary>
		[Category("Tuner Feature")]
		[Description("Enable tuner LNB power.")]
		public bool EnableLnbPower
		{
			get
			{
				return enableLnbPower_;
			}
		}

		/// <summary>
		/// `[i[ɐڑĂAeǐ݂̎Mx擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current tuning signal level.")]
		public float SignalLevel
		{
			get
			{
				return signalLevel_;
			}
		}

		/// <summary>
		/// ݎM̃Xg[̃lbg[NID擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current tuning network ID.")]
		public int NetworkID
		{
			get
			{
				return networkID_;
			}
		}

		/// <summary>
		/// ݎM̃Xg[̃lbg[N擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current tuning network name.")]
		public string NetworkName
		{
			get
			{
				return networkName_;
			}
		}

		/// <summary>
		/// ݎM̃Xg[̃gX|[gXg[ID擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current tuning transport stream ID.")]
		public int TransportStreamID
		{
			get
			{
				return transportStreamID_;
			}
		}

		/// <summary>
		/// ݎM̃Xg[̊Jn擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current tuning stream start time.")]
		public DateTime StreamTime
		{
			get
			{
				return streamTime_;
			}
		}

		/// <summary>
		/// XNȕԂ擾܂B
		/// </summary>
		[Category("Current Status")]
		[Description("Current CAS descrambling status.")]
		public DescramblingStates DescramblingStatus
		{
			get
			{
				return descramblingStatus_;
			}
		}

		/// <summary>
		/// ̃`[i[̃Xg[M邽߂URLQ擾܂B
		/// </summary>
		/// <remarks>C^[tFCX݂\邽߁AꂼURL܂܂܂B</remarks>
		[Category("Stream Service")]
		[Description("Stream service acceptable URLs.")]
		public Uri[] StreamUrls
		{
			get
			{
				return streamUrls_;
			}
		}

		/// <summary>
		/// ݂̃`[i[ɐڑĂXg[NCAg̃Gh|CgQ擾܂B
		/// </summary>
		/// <remarks>̏ŁAڑĂXg[NCAgo܂B</remarks>
		[Category("Stream Service")]
		[Description("Current stream clients.")]
		public IPEndPoint[] ClientEndPoints
		{
			get
			{
				return clientEndPoints_;
			}
		}
	}
}
