//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class DataQueue;

	namespace Internal
	{
		class ManagedBuffer;

		ref class DataQueueManager sealed
			: public System::Runtime::ConstrainedExecution::CriticalFinalizerObject,
			public System::Collections::Generic::IEnumerable<DataQueue^>
		{
		private:
			ManagedBuffer *pBuffer_;
			System::Collections::Generic::List<DataQueue^>^ queueList_;

			virtual System::Collections::IEnumerator^ IEnumerableGetEnumerator() sealed =
				System::Collections::IEnumerable::GetEnumerator;

		public:
			DataQueueManager(int bufferSize);
			~DataQueueManager();

			void RegisterQueue(DataQueue^ queue);
			int UnregisterQueue(DataQueue^ queue);

			void Clear();
			void Enqueue(const BYTE *pData, DWORD dataSize);

			virtual System::Collections::Generic::IEnumerator<DataQueue^>^ GetEnumerator();
		};
	}
}
