//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#include "stdafx.h"

#include "ManagedBuffer.h"

namespace Bon
{
	namespace Internal
	{
		void ManagedBuffer::Allocate()
		{
			array<System::Byte>^ buffer = gcnew array<System::Byte>(static_cast<int>(bufferSize_));
			System::Runtime::InteropServices::GCHandle handle(
				System::Runtime::InteropServices::GCHandle::Alloc(buffer,
				System::Runtime::InteropServices::GCHandleType::Pinned));
			handle_ = System::Runtime::InteropServices::GCHandle::ToIntPtr(handle).ToPointer();
			pBuffer_ = static_cast<BYTE *>(handle.AddrOfPinnedObject().ToPointer());
			position_ = 0;
		}

		void ManagedBuffer::Free()
		{
			System::Runtime::InteropServices::GCHandle handle(
				System::Runtime::InteropServices::GCHandle::FromIntPtr(System::IntPtr(handle_)));
			handle.Free();
		}

		ManagedBuffer::ManagedBuffer(int bufferSize)
			: handle_(0), pBuffer_(0), bufferSize_(bufferSize), position_(0)
		{
			Allocate();
		}

		ManagedBuffer::~ManagedBuffer()
		{
			Free();
		}

		const DWORD ManagedBuffer::GetSize() const
		{
			return bufferSize_;
		}

		const DWORD ManagedBuffer::GetPosition() const
		{
			return position_;
		}

		const BYTE *ManagedBuffer::GetData() const
		{
			return pBuffer_;
		}

		bool ManagedBuffer::CopyIn(const BYTE *pData, DWORD size)
		{
			if ((size + position_) > bufferSize_)
			{
				return false;
			}
			memcpy(pBuffer_ + position_, pData, size);
			position_ += size;

			return true;
		}

		array<System::Byte>^ ManagedBuffer::GetManagedData()
		{
			System::Runtime::InteropServices::GCHandle handle(
				System::Runtime::InteropServices::GCHandle::FromIntPtr(System::IntPtr(handle_)));
			return static_cast<array<System::Byte>^>(handle.Target);
		}

		void ManagedBuffer::Renew()
		{
			Free();
			Allocate();
		}
	}
}
