//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service remote controller
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration.Install;
using System.Reflection;
using Microsoft.Win32;

namespace Bon
{
	[DesignTimeVisible(false)]
	[RunInstaller(true)]
	public partial class RemoteControllerInstaller : Installer
	{
		public RemoteControllerInstaller()
		{
			InitializeComponent();
		}

		public override void Install(System.Collections.IDictionary stateSaver)
		{
			using (RegistryKey key = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\Run", true))
			{
				string path = Assembly.GetExecutingAssembly().Location;
				key.SetValue("Bon.RemoteController", string.Format("\"{0}\" /minimized", path));
			}
			base.Install(stateSaver);
		}

		public override void Rollback(System.Collections.IDictionary savedState)
		{
			base.Rollback(savedState);
			using (RegistryKey key = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\Run", true))
			{
				string path = Assembly.GetExecutingAssembly().Location;
				key.DeleteValue("Bon.RemoteController");
			}
		}

		public override void Uninstall(System.Collections.IDictionary savedState)
		{
			base.Uninstall(savedState);
			using (RegistryKey key = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\Run", true))
			{
				string path = Assembly.GetExecutingAssembly().Location;
				key.DeleteValue("Bon.RemoteController");
			}
		}
	}
}