//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service remote controller
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Bon.Remoting;

namespace Bon
{
	/// <summary>
	/// R[_[̃Xg[WIDƃXg[URLItH[łB
	/// </summary>
	/// <remarks>Ȉ՘^JnŎgp܂B</remarks>
	internal partial class SelectRecorderForm : Form
	{
		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="tuningSpace">`[jOXy[X</param>
		/// <param name="channel">`l</param>
		/// <param name="programID">vOID</param>
		/// <param name="tags">R[_[񋓂邽߂̃^OQ</param>
		/// <param name="streamUrls">Xg[URLQ</param>
		/// <param name="lastFileName">Ōɓ͂Ăt@C</param>
		/// <param name="lastStreamServiceBaseUrl">ŌɑIĂXg[T[rXx[XURL</param>
		/// <param name="lastStorageID">ŌɑIĂXg[WID</param>
		/// <param name="lastStreamUrl">ŌɑIĂXg[URL</param>
		public SelectRecorderForm(
			int tuningSpace, int channel, int programID,
			IEnumerable<StreamServiceTag> tags, Uri[] streamUrls,
			string lastFileName, Uri lastStreamServiceBaseUrl, string lastStorageID, Uri lastStreamUrl)
		{
			InitializeComponent();

			programTextBox.Text = string.Format("{0}:{1}:{2}", tuningSpace, channel, programID);
			fileNameTextBox.Text = lastFileName;

			// R[_[񋓂ăc[r[𐶐
			Dictionary<string, TreeNode> nodeDictionary = new Dictionary<string, TreeNode>();
			foreach (StreamServiceTag tag in tags)
			{
				try
				{
					string[] storageIDs = tag.Recorder.StorageIDs;
					TreeNode streamServiceNode = new TreeNode(
						string.Format("{0}:{1}{2}", tag.StreamServiceBaseUrl.Host, tag.StreamServiceBaseUrl.Port,
						tag.Recorder.Enabled ? string.Empty : " (Disabled)"));
					streamServiceNode.ImageIndex = 0;
					streamServiceNode.SelectedImageIndex = 0;
					foreach (string storageID in storageIDs)
					{
						long currentSpace = tag.Recorder.GetCurrentSpaces(storageID);
						TreeNode storageIDNode = new TreeNode(
							string.Format("{0} / {1} MB", storageID, currentSpace / 1024 / 1024));
						storageIDNode.ImageIndex = 1;
						storageIDNode.SelectedImageIndex = 1;
						storageIDNode.Tag = new KeyValuePair<StreamServiceTag, string>(tag, storageID);
						streamServiceNode.Nodes.Add(storageIDNode);
						nodeDictionary.Add(tag.StreamServiceBaseUrl.ToString() + storageID, storageIDNode);
					}
					storageTreeView.Nodes.Add(streamServiceNode);
				}
				catch
				{
				}
			}

			storageTreeView.ExpandAll();

			// ŌɑIĂXg[WIDČ
			if ((lastStreamServiceBaseUrl != null) && (string.IsNullOrEmpty(lastStorageID) == false))
			{
				TreeNode lastNode = null;
				if (nodeDictionary.TryGetValue(lastStreamServiceBaseUrl.ToString() + lastStorageID, out lastNode) == true)
				{
					storageTreeView.SelectedNode = lastNode;
				}
			}

			// Xg[URL񋓂
			Dictionary<Uri, ListViewItem> itemDictionary = new Dictionary<Uri, ListViewItem>();
			foreach (Uri streamUrl in streamUrls)
			{
				ListViewItem item = new ListViewItem(string.Format("{0}:{1}", streamUrl.Host, streamUrl.Port));
				item.ImageIndex = 2;
				item.Tag = streamUrl;
				streamListView.Items.Add(item);
				itemDictionary.Add(streamUrl, item);
			}

			// ŌɑIĂXg[URLČ
			if (lastStreamUrl != null)
			{
				ListViewItem lastItem = null;
				if (itemDictionary.TryGetValue(lastStreamUrl, out lastItem) == true)
				{
					lastItem.Selected = true;
				}
			}
		}

		/// <summary>
		/// {^̏ԂXV܂B
		/// </summary>
		private void UpdateButton()
		{
			if (streamListView.SelectedItems.Count == 0)
			{
				okButton.Enabled = false;
				return;
			}

			if (fileNameTextBox.Text.Length == 0)
			{
				okButton.Enabled = false;
				return;
			}

			TreeNode selectedNode = storageTreeView.SelectedNode;
			if (selectedNode == null)
			{
				okButton.Enabled = false;
				return;
			}

			if (selectedNode.Tag is KeyValuePair<StreamServiceTag, string>)
			{
				okButton.Enabled = true;
			}
			else
			{
				okButton.Enabled = false;
			}
		}

		/// <summary>
		/// t@CeLXg{bNXύXꂽB
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void fileNameTextBox_TextChanged(object sender, EventArgs e)
		{
			UpdateButton();
		}

		/// <summary>
		/// c[r[̃m[hIꂽB
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void treeView_AfterSelect(object sender, TreeViewEventArgs e)
		{
			UpdateButton();
		}

		/// <summary>
		/// Xgr[̃ACeIꂽB
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void listView_SelectedIndexChanged(object sender, EventArgs e)
		{
			UpdateButton();
		}

		/// <summary>
		/// ͂ꂽt@C擾܂B
		/// </summary>
		public string FileName
		{
			get
			{
				return fileNameTextBox.Text;
			}
		}

		/// <summary>
		/// IꂽR[_[^O擾܂B
		/// </summary>
		public StreamServiceTag SelectedRecorder
		{
			get
			{
				return ((KeyValuePair<StreamServiceTag, string>)storageTreeView.SelectedNode.Tag).Key;
			}
		}

		/// <summary>
		/// IꂽXg[WID擾܂B
		/// </summary>
		public string StorageID
		{
			get
			{
				return ((KeyValuePair<StreamServiceTag, string>)storageTreeView.SelectedNode.Tag).Value;
			}
		}

		/// <summary>
		/// IꂽXg[URL擾܂B
		/// </summary>
		public Uri StreamUrl
		{
			get
			{
				return (Uri)streamListView.SelectedItems[0].Tag;
			}
		}
	}
}