//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Bon
{
	public partial class EventLogDetailForm : Form
	{
		public EventLogDetailForm(EventLogEntry entry)
		{
			InitializeComponent();

			this.Text = entry.TimeGenerated.ToString("yyyy/MM/dd HH:mm:ss");
			switch (entry.EntryType)
			{
				case EventLogEntryType.Error:
					this.Icon = SystemIcons.Error;
					break;
				case EventLogEntryType.Warning:
					this.Icon = SystemIcons.Warning;
					break;
				case EventLogEntryType.Information:
					this.Icon = SystemIcons.Information;
					break;
				case EventLogEntryType.SuccessAudit:
					this.Icon = SystemIcons.Information;
					break;
				case EventLogEntryType.FailureAudit:
					this.Icon = SystemIcons.Error;
					break;
				default:
					this.Icon = SystemIcons.Question;
					break;
			}

			propertyGrid.SelectedObject = entry;
		}
	}
}