//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing.Design;
using System.Globalization;
using System.Text;
using Microsoft.Win32;

namespace Bon
{
	/// <summary>
	/// w肳ꂽWXgL[ARNVƂđo悤ɂNXłB
	/// </summary>
	/// <remarks>RNVł͊IɁuL[vƌĂԃXL[AΉ郌WXgł́ulvƌĂсAWXgɂẮuL[vƂ͈قȂ邽ߒӂĉB
	/// ܂AIListC^[tFCẌꕔ̃o͖łAĂяoꍇNotImplementedExceptionX[܂B</remarks>
	internal sealed class RegistryDictionary : IDictionary<string, string>, IDictionary, IList, IDisposable
	{
		private RegistryKey key_;
		private readonly bool writable_;
		private readonly CultureInfo cultureInfo_;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="key">x[XWXgL[</param>
		/// <param name="path">TuL[ւ̃pX</param>
		/// <param name="writable">݂\ɂꍇtrue</param>
		/// <param name="cultureInfo">l̎擾EݒɎgpJ`</param>
		public RegistryDictionary(RegistryKey key, string path, bool writable, CultureInfo cultureInfo)
		{
			writable_ = writable;
			cultureInfo_ = cultureInfo;
			try
			{
				key_ = key.OpenSubKey(path, writable_);
			}
			catch
			{
			}
			if ((key_ == null) && (writable_ == true))
			{
				key_ = key.CreateSubKey(path);
			}
		}

		/// <summary>
		/// t@CiCUłB
		/// </summary>
		~RegistryDictionary()
		{
			Dispose();
		}

		/// <summary>
		/// Dispose\bhłB
		/// </summary>
		/// <remarks>L[N[Y܂B</remarks>
		public void Dispose()
		{
			if (key_ != null)
			{
				key_.Close();
				key_ = null;
				GC.SuppressFinalize(this);
			}
		}

		/// <summary>
		/// L[擾܂B
		/// </summary>
		public string Name
		{
			get
			{
				return key_.Name;
			}
		}

		/// <summary>
		/// L[Ɋ܂܂lQ̐擾܂B
		/// </summary>
		public int Count
		{
			get
			{
				return key_.ValueCount;
			}
		}

		/// <summary>
		/// ̃RNVǂݎpǂ擾܂B
		/// </summary>
		public bool IsReadOnly
		{
			get
			{
				return writable_ == false;
			}
		}

		/// <summary>
		/// ̃RNVĂ邩ǂ擾܂B
		/// </summary>
		/// <remarks>̃vpeB͏falsełAWXgւ̃ANZX𓯎ɍsĂj͐܂B</remarks>
		public bool IsSynchronized
		{
			get
			{
				return false;
			}
		}

		/// <summary>
		/// ̃RNV̓IuWFNg擾܂B
		/// </summary>
		/// <remarks>̓IuWFNggpēsĂAقȂvZX̃WXgւ̔r͎܂B</remarks>
		public object SyncRoot
		{
			get
			{
				return this;
			}
		}

		/// <summary>
		/// lQ擾܂B
		/// </summary>
		public ICollection<string> Keys
		{
			get
			{
				return key_.GetValueNames();
			}
		}

		/// <summary>
		/// lQ擾܂B
		/// </summary>
		public ICollection<string> Values
		{
			get
			{
				List<string> values = new List<string>();
				foreach (string name in key_.GetValueNames())
				{
					object rawValue = key_.GetValue(name);
					if (rawValue != null)
					{
						string value = Convert.ToString(rawValue, cultureInfo_);
						values.Add(value);
					}
				}
				return values.ToArray();
			}
		}

		/// <summary>
		/// lŒl擾Eݒ肷CfNTłB
		/// </summary>
		/// <param name="key">l</param>
		/// <returns>l</returns>
		public string this[string key]
		{
			get
			{
				object rawValue = key_.GetValue(key);
				if (rawValue == null)
				{
					throw new KeyNotFoundException(key);
				}
				string value = Convert.ToString(rawValue, cultureInfo_);
				return value;
			}
			set
			{
				key_.SetValue(key, value);
			}
		}

		/// <summary>
		/// w肳ꂽl܂܂Ă邩ǂmF܂B
		/// </summary>
		/// <param name="key">l</param>
		/// <returns>l܂܂Ătrue</returns>
		public bool ContainsKey(string key)
		{
			return key_.GetValue(key) != null;
		}

		/// <summary>
		/// w肳ꂽl̒l擾܂B
		/// </summary>
		/// <param name="key">l</param>
		/// <param name="value">li[Q</param>
		/// <returns>l擾ꍇtrue</returns>
		public bool TryGetValue(string key, out string value)
		{
			object rawValue = key_.GetValue(key);
			if (rawValue == null)
			{
				value = null;
				return false;
			}
			value = Convert.ToString(rawValue, cultureInfo_);
			return true;
		}

		/// <summary>
		/// lǉ܂B
		/// </summary>
		/// <param name="key">l</param>
		/// <param name="value">l</param>
		public void Add(string key, string value)
		{
			key_.SetValue(key, value);
		}

		/// <summary>
		/// w肳ꂽl폜܂B
		/// </summary>
		/// <param name="key">l</param>
		/// <returns>l݂Ăꍇtrue</returns>
		public bool Remove(string key)
		{
			try
			{
				key_.DeleteValue(key, true);
			}
			catch (ArgumentException)
			{
				return false;
			}
			return true;
		}

		/// <summary>
		/// SĂ̒l폜܂B
		/// </summary>
		/// <remarks>TuL[͑Ώۂł͂܂B</remarks>
		public void Clear()
		{
			foreach (string name in key_.GetValueNames())
			{
				key_.DeleteValue(name, false);
			}
		}

		/// <summary>
		/// ̃RNV񋓂܂B
		/// </summary>
		/// <returns>lƒlyAƂȂ񋓎q</returns>
		public IEnumerator<KeyValuePair<string, string>> GetEnumerator()
		{
			List<KeyValuePair<string, string>> list = new List<KeyValuePair<string, string>>();
			foreach (string name in key_.GetValueNames())
			{
				object rawValue = key_.GetValue(name);
				if (rawValue != null)
				{
					string value = Convert.ToString(rawValue, cultureInfo_);
					list.Add(new KeyValuePair<string, string>(name, value));
				}
			}
			return list.GetEnumerator();
		}

		#region Advanced
		[EditorBrowsable(EditorBrowsableState.Advanced)]
		public void Add(KeyValuePair<string, string> item)
		{
			key_.SetValue(item.Key, item.Value);
		}

		[EditorBrowsable(EditorBrowsableState.Advanced)]
		public bool Contains(KeyValuePair<string, string> item)
		{
			object rawValue = key_.GetValue(item.Key);
			if (rawValue == null)
			{
				return false;
			}
			string value = Convert.ToString(rawValue, cultureInfo_);
			return item.Value.Equals(value);
		}

		[EditorBrowsable(EditorBrowsableState.Advanced)]
		public void CopyTo(KeyValuePair<string, string>[] array, int arrayIndex)
		{
			int position = arrayIndex;
			foreach (string name in key_.GetValueNames())
			{
				object rawValue = key_.GetValue(name);
				if (rawValue != null)
				{
					string value = Convert.ToString(rawValue, cultureInfo_);
					array[position] = new KeyValuePair<string, string>(name, value);
				}
			}
		}

		[EditorBrowsable(EditorBrowsableState.Advanced)]
		public bool Remove(KeyValuePair<string, string> item)
		{
			object rawValue = key_.GetValue(item.Key);
			if (rawValue == null)
			{
				return false;
			}
			string value = Convert.ToString(rawValue, cultureInfo_);
			if (item.Value.Equals(value) == false)
			{
				return false;
			}
			key_.DeleteValue(item.Key);
			return true;
		}
		#endregion

		#region IDictionary
		bool IDictionary.IsFixedSize
		{
			get
			{
				return false;
			}
		}

		ICollection IDictionary.Keys
		{
			get
			{
				return key_.GetValueNames();
			}
		}

		ICollection IDictionary.Values
		{
			get
			{
				List<string> values = new List<string>();
				foreach (string name in key_.GetValueNames())
				{
					object rawValue = key_.GetValue(name);
					if (rawValue != null)
					{
						string value = Convert.ToString(rawValue, cultureInfo_);
						values.Add(value);
					}
				}
				return values.ToArray();
			}
		}

		bool IDictionary.Contains(object key)
		{
			return this.ContainsKey(key as string);
		}

		object IDictionary.this[object key]
		{
			get
			{
				return this[key as string];
			}
			set
			{
				this[key as string] = value as string;
			}
		}

		void IDictionary.Add(object key, object value)
		{
			this.Add(key as string, value as string);
		}

		void IDictionary.Remove(object key)
		{
			this.Remove(key as string);
		}

		IDictionaryEnumerator IDictionary.GetEnumerator()
		{
			Hashtable list = new Hashtable();
			foreach (string name in key_.GetValueNames())
			{
				object rawValue = key_.GetValue(name);
				if (rawValue != null)
				{
					string value = Convert.ToString(rawValue, cultureInfo_);
					list.Add(name, value);
				}
			}
			return list.GetEnumerator();
		}
		#endregion

		#region IList
		bool IList.IsFixedSize
		{
			get
			{
				return false;
			}
		}

		object IList.this[int index]
		{
			get
			{
				throw new NotImplementedException("The method or operation is not implemented.");
			}
			set
			{
				throw new NotImplementedException("The method or operation is not implemented.");
			}
		}

		bool IList.Contains(object value)
		{
			return this.Contains((KeyValuePair<string, string>)value);
		}

		int IList.IndexOf(object value)
		{
			throw new NotImplementedException("The method or operation is not implemented.");
		}

		int IList.Add(object value)
		{
			this.Add((KeyValuePair<string, string>)value);
			return this.Count - 1;
		}

		void IList.Insert(int index, object value)
		{
			throw new NotImplementedException("The method or operation is not implemented.");
		}

		void IList.Remove(object value)
		{
			this.Remove((KeyValuePair<string, string>)value);
		}

		void IList.RemoveAt(int index)
		{
			throw new NotImplementedException("The method or operation is not implemented.");
		}
		#endregion

		#region ICollection
		void ICollection.CopyTo(Array array, int index)
		{
			this.CopyTo((KeyValuePair<string, string>[])array, index);
		}
		#endregion

		#region IEnumerable
		IEnumerator IEnumerable.GetEnumerator()
		{
			return this.GetEnumerator();
		}
		#endregion
	}
}
