//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.Design;

namespace Bon
{
	/// <summary>
	/// ҏWɎgplƒlێNXłB
	/// </summary>
	internal abstract class SelectableNameValueBase
	{
		private string name_;
		private string value_ = string.Empty;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		protected SelectableNameValueBase()
		{
			name_ = string.Format("New{0}", this.GetType().Name);
		}

		/// <summary>
		/// l擾Eݒ肵܂B
		/// </summary>
		/// <remarks>I[o[Chă^CvRo[^ݒ肵ĉB</remarks>
		public virtual string Name
		{
			get
			{
				return name_;
			}
			set
			{
				name_ = value;
			}
		}

		/// <summary>
		/// l擾Eݒ肵܂B
		/// </summary>
		/// <remarks>I[o[Chă^CvRo[^ݒ肵ĉB</remarks>
		public virtual string Value
		{
			get
			{
				return value_;
			}
			set
			{
				value_ = value;
			}
		}
	}

	/// <summary>
	/// w肳ꂽRNV^瓾lQI\ɂ^CvRo[^łB
	/// </summary>
	/// <typeparam name="T">RNV^</typeparam>
	internal sealed class SelectableValueConverter<T> : StringConverter
		where T : ICollection, new()
	{
		private static readonly ICollection defaults_;

		/// <summary>
		/// ^CvCjVCUłB
		/// </summary>
		static SelectableValueConverter()
		{
			SortedList temp = new SortedList();
			foreach (object value in new T())
			{
				temp[value] = value;
			}
			defaults_ = temp.Keys;
		}

		/// <summary>
		/// RXgN^łB
		/// </summary>
		public SelectableValueConverter()
		{
		}

		/// <summary>
		/// WlQ̃T|[gLǂ擾܂B
		/// </summary>
		/// <param name="context">^CvLqq݂̌̃ReLXg</param>
		/// <returns>true</returns>
		public override bool GetStandardValuesSupported(ITypeDescriptorContext context)
		{
			return true;
		}

		/// <summary>
		/// WlQȊO̒l󂯕tȂ悤ɂ邩ǂ擾܂B
		/// </summary>
		/// <param name="context">^CvLqq݂̌̃ReLXg</param>
		/// <returns>false</returns>
		public override bool GetStandardValuesExclusive(ITypeDescriptorContext context)
		{
			return false;
		}

		/// <summary>
		/// WlQ擾܂B
		/// </summary>
		/// <param name="context">^CvLqq݂̌̃ReLXg</param>
		/// <returns>WlQi[RNV</returns>
		public override StandardValuesCollection GetStandardValues(ITypeDescriptorContext context)
		{
			return new StandardValuesCollection(defaults_);
		}
	}

	/// <summary>
	/// IDictionaryC^[tFCXɑΉRNVGfB^łB
	/// </summary>
	/// <typeparam name="T">SelectableNameValueBasepNX</typeparam>
	internal sealed class SelectableDictionaryEditor<T> : CollectionEditor
		where T : SelectableNameValueBase, new()
	{
		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="type">GfB^ŕҏWRNV̌^</param>
		public SelectableDictionaryEditor(Type type)
			: base(type)
		{
		}

		/// <summary>
		/// RNV̊eڂ̃f[^^擾܂B
		/// </summary>
		/// <returns>RNVڂ̃f[^^</returns>
		protected override Type CreateCollectionItemType()
		{
			return typeof(T);
		}

		/// <summary>
		/// w肵RNVڂ̌^̐VCX^X쐬܂B
		/// </summary>
		/// <param name="itemType">쐬鍀ڂ̌^B</param>
		/// <returns>w肵IuWFNg̐VCX^XB</returns>
		protected override object CreateInstance(Type itemType)
		{
			return new T();
		}

		/// <summary>
		/// w肵RNVi[ĂIuWFNgz擾܂B
		/// </summary>
		/// <param name="editValue">ҏWΏۂ̃RNVB</param>
		/// <returns>RNV IuWFNgi[ĂzB</returns>
		protected override object[] GetItems(object editValue)
		{
			if (editValue == null)
			{
				return new object[0];
			}
			IDictionary dictionary = editValue as IDictionary;
			if (dictionary == null)
			{
				throw new ArgumentNullException("editValue");
			}
			SortedList<string, T> result = new SortedList<string, T>();
			foreach (DictionaryEntry entry in dictionary)
			{
				T nameValue = new T();
				nameValue.Name = entry.Key.ToString();
				nameValue.Value = entry.Value.ToString();
				result.Add(nameValue.Name, nameValue);
			}
			return new List<T>(result.Values).ToArray();
		}

		/// <summary>
		/// w肵zRNV̍ڂƂĐݒ肵܂B
		/// </summary>
		/// <param name="editValue">ҏWΏۂ̃RNVB</param>
		/// <param name="value">RNVڂƂĐݒ肷IuWFNgzB</param>
		/// <returns>V쐬ꂽRNVIuWFNgB</returns>
		protected override object SetItems(object editValue, object[] value)
		{
			IDictionary dictionary = editValue as IDictionary;
			if (dictionary == null)
			{
				throw new ArgumentNullException("editValue");
			}
			dictionary.Clear();
			foreach (T entry in value)
			{
				dictionary.Add(entry.Name, entry.Value);
			}
			return dictionary;
		}
	}
}
