//////////////////////////////////////////////////////////////////////////
// BonSDK library header file
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// BonDebug.h: fobO⏕Cu
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


namespace Bon
{

#ifdef _DEBUG
	// fobOrh
	#define BON_IS_DEBUG	true
#else
	// [Xrh
	#define BON_IS_DEBUG	false
#endif



/////////////////////////////////////////////////////////////////////////////
// ėpONX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CBonException
{
public:
	CBonException(LPCSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId, LPCTSTR pDescription = 0);
	CBonException(LPCWSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId, LPCTSTR pDescription = 0);
	CBonException(const CBonException &rhs);
	virtual ~CBonException(void);

	CBonException &operator =(const CBonException &);
	CBonException &operator ()(LPCTSTR lpszFormat = 0, ...);

	const BONGUID GetGuid(void) const;
	const CBonString GetDescription() const;
	const CBonString GetSourceFile() const;
	const DWORD GetSourceLine(void) const;

protected:
	BONGUID m_ClassId;
	CBonString m_Description;
	CBonString m_SourceFile;
	DWORD m_dwSourceLine;
};


/////////////////////////////////////////////////////////////////////////////
// ėpƍNX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CBonAssert
{
public:
	CBonAssert(LPCSTR lpszSourceFile, const DWORD dwSourceLine, const BONGUID ClassId);

	void operator ()(const bool bSuccess = false, LPCTSTR lpszFormat = 0, ...);
	void operator ()(const void *pPointer, LPCTSTR lpszFormat = 0, ...);
	
protected:
	const BONGUID m_ClassId;
	const CBonString m_SourceFile;
	const DWORD m_dwSourceLine;

private:
	void InternalAssert(const CBonString &message);

	CBonAssert(const CBonAssert &);
	void operator =(const CBonAssert &);
};


/*

class CPerfInspector
{
protected:
	class CPerfInitializer
	{
	public:
		CPerfInitializer()
		{
			::BON_TRACE(TEXT("CPerfInitializer()\n"));
			::QueryPerformanceFrequency((LARGE_INTEGER *)&m_llCounterFreq);
		}
	
		LONGLONG m_llCounterFreq;
	};

public:
	CPerfInspector()
	{
		::QueryPerformanceCounter((LARGE_INTEGER *)&m_llStartTime);
	}
	
	~CPerfInspector()
	{
		LONGLONG m_llEndTime = m_llStartTime;
		::QueryPerformanceCounter((LARGE_INTEGER *)&m_llEndTime);

		m_llEndTime = ((m_llEndTime - m_llStartTime) * 1000000LL) / m_PerfCounter.m_llCounterFreq;
		
		::BON_TRACE(TEXT("Block Process Time = %luus\n"), (DWORD)m_llEndTime);		
	}

protected:
	LONGLONG m_llStartTime;
	static CPerfInitializer m_PerfCounter;
};

CPerfInspector::CPerfInitializer CPerfInspector::m_PerfCounter;

*/


/////////////////////////////////////////////////////////////////////////////
// fobO⏕}N
/////////////////////////////////////////////////////////////////////////////

#define BON_EXPECTION	CBonException(__FILE__, __LINE__, GetGuid())
#define BON_ASSERT		CBonAssert(__FILE__, __LINE__, GetGuid())


/////////////////////////////////////////////////////////////////////////////
// fobO⏕֐
/////////////////////////////////////////////////////////////////////////////

BONAPI const BONGUID GetGuid(void);

}


/////////////////////////////////////////////////////////////////////////////
// g[Xo
/////////////////////////////////////////////////////////////////////////////

// g[Xo͂ HKLM\SOFTWARE\BonSDK\BonTraceMask (DWORD) ̃}XNlŐ\B
// ftHǵAfobOrh 0xffffffffULA[X 0xfffffffeUL w肳ꂽԂƂȂB
enum BonTraceType
{
	TraceType_Debug = 1,
	TraceType_Information = 2,
	TraceType_Warning = 4,
	TraceType_Error = 8
};

extern "C" BONAPI void BON_TRACE(BonTraceType type, LPCTSTR lpszFormat, ...);
BONAPI void BON_TRACE(BonTraceType type, const Bon::CBonString &message);

// g[Xo͂tbN\ (ftHgł OutputDebugString() API gp)
typedef void (*PTRACE_CALLBACK)(BonTraceType type, LPCTSTR lpszMessage);
extern "C" BONAPI void BON_TRACE_REGISTER_CALLBACK(PTRACE_CALLBACK pCallback = 0);

// g[Xo͑Ώۂǂ擾
// OŏLWXg̒lQƂďo͂肷̂ɎgpB
extern "C" BONAPI bool IS_BON_TRACE_TARGET(BonTraceType type);
