//////////////////////////////////////////////////////////////////////////
// BonSDK library header file
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// BonString.h: NX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <string>


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// NX
/////////////////////////////////////////////////////////////////////////////

class CSmartLock;

// Rs[RXgN^Ƒ́AQƃJEgɂĎۂ̕Rs[
// yĂBj󑀍삪sƂ Fork \bhĂяoāA
// ŗL̕CX^Xێ悤ɂȂB
// QƃJEg̑iRs[RXgN^Ƒj̓XbhZ[tA
// ̂ق̑̓XbhZ[tł͂ȂƂɒӁB
class BONAPI CBonString
{
public:
	CBonString();
	CBonString(const char ch);
	CBonString(const wchar_t ch);
	CBonString(const char *pString);
	CBonString(const wchar_t *pString);
	CBonString(const CBonString &rhs);
	~CBonString();

	const int GetLength() const;
	const bool IsEmpty() const;

	void Clear();

	TCHAR &operator [](int index);
	const TCHAR &operator [](int index) const;
	
	operator const TCHAR *() const;
	const TCHAR *GetString() const;

	operator const bool() const;
	const bool operator !() const;

	CBonString &operator =(const char ch);
	CBonString &operator =(const wchar_t ch);
	CBonString &operator =(const char *pString);
	CBonString &operator =(const wchar_t *pString);
	CBonString &operator =(const CBonString &rhs);

	CBonString &operator +=(const char ch);
	CBonString &operator +=(const wchar_t ch);
	CBonString &operator +=(const char *pString);
	CBonString &operator +=(const wchar_t *pString);
	CBonString &operator +=(const CBonString &rhs);

	friend CBonString operator +(const CBonString &lhs, const char ch);
	friend CBonString operator +(const CBonString &lhs, const wchar_t ch);
	friend CBonString operator +(const CBonString &lhs, const char *pString);
	friend CBonString operator +(const CBonString &lhs, const wchar_t *pString);
	friend CBonString operator +(const char ch, const CBonString &rhs);
	friend CBonString operator +(const wchar_t ch, const CBonString &rhs);
	friend CBonString operator +(const char *pString, const CBonString &rhs);
	friend CBonString operator +(const wchar_t *pString, const CBonString &rhs);
	friend CBonString operator +(const CBonString &lhs, const CBonString &rhs);

	// Format, AppendFormat ̃tH[}bǵAFormatMessage API ɏB
	// printf ̃tH[}bgƂ͈قȂ邽ߒӁB
	static CBonString Format(const char *pFormat, ...);
	static CBonString Format(const wchar_t *pFormat, ...);
	static CBonString FormatV(const char *pFormat, va_list va);
	static CBonString FormatV(const wchar_t *pFormat, va_list va);

	CBonString &AppendFormat(const char *pFormat, ...);
	CBonString &AppendFormat(const wchar_t *pFormat, ...);
	CBonString &AppendFormatV(const char *pFormat, va_list va);
	CBonString &AppendFormatV(const wchar_t *pFormat, va_list va);

	friend bool operator ==(const CBonString &lhs, const char *pString);
	friend bool operator ==(const CBonString &lhs, const wchar_t *pString);
	friend bool operator ==(const char *pString, const CBonString &rhs);
	friend bool operator ==(const wchar_t *pString, const CBonString &rhs);
	friend bool operator ==(const CBonString &lhs, const CBonString &rhs);

	friend bool operator !=(const CBonString &lhs, const char *pString);
	friend bool operator !=(const CBonString &lhs, const wchar_t *pString);
	friend bool operator !=(const char *pString, const CBonString &rhs);
	friend bool operator !=(const wchar_t *pString, const CBonString &rhs);
	friend bool operator !=(const CBonString &lhs, const CBonString &rhs);

	static const CBonString &GetEmpty();

private:
	void Fork();

	class String;

	mutable String *m_pString;
};

}
