//////////////////////////////////////////////////////////////////////////
// BonSDK Core engine library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// MediaBase.cpp: BonfBANX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "MediaBase.h"

#include <assert.h>


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// CMediaDataHeapNX
/////////////////////////////////////////////////////////////////////////////
	
// fobO̓[Nô C Heap gA[X Win32 API gpāA
// q[vԂCq[v؂藣ƂŁAf̉e󂯂ɂB
// ̕ Win32 API ̃q[v͍ƋLqĂ邪Aۂ̂Ƃ͂킩ȂB

#if 0
CMediaDataHeap::CMediaDataHeap(IBonObject *pOwner, const DWORD dwInitialSpace)
	: CBonObject(pOwner)
{
	UNREFERENCED_PARAMETER(dwInitialSpace);
}

CMediaDataHeap::~CMediaDataHeap()
{
}

BYTE *CMediaDataHeap::Allocate(DWORD size)
{
	BYTE *pBuffer = static_cast<BYTE *>(malloc(size));
	if (pBuffer == 0)
	{
		BON_ASSERT(false, TEXT("Cannot allocate memory: size=%1!ld!"), size);
	}
	return pBuffer;
}

void CMediaDataHeap::Free(BYTE *pBuffer)
{
	free(pBuffer);
}
#else
CMediaDataHeap::CMediaDataHeap(IBonObject *pOwner, const DWORD dwInitialSpace)
	: CBonObject(pOwner), m_Handle(HeapCreate(0, dwInitialSpace, 0))
{
}

CMediaDataHeap::~CMediaDataHeap()
{
	HeapDestroy(m_Handle);
}

BYTE *CMediaDataHeap::Allocate(DWORD size)
{
	BYTE *pBuffer = static_cast<BYTE *>(HeapAlloc(m_Handle, 0, size));
	if (pBuffer == 0)
	{
		BON_ASSERT(false, TEXT("Cannot allocate memory: size=%1!ld!"), size);
	}
	return pBuffer;
}

void CMediaDataHeap::Free(BYTE *pBuffer)
{
	HeapFree(m_Handle, 0, pBuffer);
}
#endif


// ftHg̃q[vč폜Ȃ悤ɂt@T[hNX
class CDefaultMediaDataHeap : public IMediaDataHeap
{
private:
	CMediaDataHeap m_Heap;

	CDefaultMediaDataHeap(const CDefaultMediaDataHeap &);
	void operator =(const CDefaultMediaDataHeap &);

public:
	CDefaultMediaDataHeap()
	{
	}

	void Release()
	{
		// Ȃ
	}

	const BONGUID GetGuid(void) const
	{
		return m_Heap.GetGuid();
	}

	BYTE *Allocate(DWORD size)
	{
		return m_Heap.Allocate(size);
	}

	void Free(BYTE *pBuffer)
	{
		return m_Heap.Free(pBuffer);
	}
};

// ftHgq[ṽCX^X
static CDefaultMediaDataHeap g_DefaultMediaDataHeap;


/////////////////////////////////////////////////////////////////////////////
// IMediaDataNX
/////////////////////////////////////////////////////////////////////////////

#define	MINBUFSIZE	256UL		// ŏobt@TCY
#define MINADDSIZE	256UL		// ŏǉmۃTCY


BYTE *CMediaData::GetData(void)
{
	// obt@|C^擾
	return (m_dwDataSize)? m_pData : NULL;
}

const BYTE *CMediaData::GetData(void) const
{
	// obt@|C^擾
	return (m_dwDataSize)? m_pData : NULL;
}

const DWORD CMediaData::GetSize(void) const
{
	// f[^TCY擾
	return m_dwDataSize;
}

void CMediaData::SetAt(const DWORD dwPos, const BYTE byData)
{
	// 1oCgZbg
	if(dwPos < m_dwDataSize)m_pData[dwPos] = byData;
}

const BYTE CMediaData::GetAt(const DWORD dwPos) const
{
	// 1oCg擾
	return (dwPos < m_dwDataSize)? m_pData[dwPos] : 0x00U;
}

const DWORD CMediaData::SetData(const BYTE *pData, const DWORD dwDataSize)
{
	if(dwDataSize){
		// obt@m
		GetBuffer(dwDataSize);

		// f[^Zbg
		::CopyMemory(m_pData, pData, dwDataSize);
		}

	// TCYZbg
	m_dwDataSize = dwDataSize;
	
	return m_dwDataSize;
}

const DWORD CMediaData::AddData(const BYTE *pData, const DWORD dwDataSize)
{
	if(!dwDataSize)return m_dwDataSize;

	// obt@m
	GetBuffer(m_dwDataSize + dwDataSize);
	
	// f[^ǉ
	::CopyMemory(&m_pData[m_dwDataSize], pData, dwDataSize);

	// TCYZbg
	m_dwDataSize += dwDataSize;
	
	return m_dwDataSize;
}

const DWORD CMediaData::AddData(const IMediaData *pData)
{
	return AddData(pData->GetData(), pData->GetSize());
}

const DWORD CMediaData::AddByte(const BYTE byData)
{
	// obt@m
	GetBuffer(m_dwDataSize + 1UL);
	
	// f[^ǉ
	m_pData[m_dwDataSize] = byData;

	// TCYXV
	m_dwDataSize++;

	return m_dwDataSize;
}

const DWORD CMediaData::TrimHead(const DWORD dwTrimSize)
{
	// f[^擪؂l߂
	if(!m_dwDataSize || !dwTrimSize){
		// Ȃ
		}
	else if(dwTrimSize >= m_dwDataSize){
		// Ŝ؂l߂
		m_dwDataSize = 0UL;		
		}
	else{
		// f[^ړ
		::MoveMemory(m_pData, m_pData + dwTrimSize, m_dwDataSize - dwTrimSize);
		m_dwDataSize -= dwTrimSize;
		}

	return m_dwDataSize;
}

const DWORD CMediaData::TrimTail(const DWORD dwTrimSize)
{
	// f[^؂l߂
	if(!m_dwDataSize || !dwTrimSize){
		// Ȃ
		}
	else if(dwTrimSize >= m_dwDataSize){
		// Ŝ؂l߂
		m_dwDataSize = 0UL;		
		}
	else{
		// f[^؂l߂
		m_dwDataSize -= dwTrimSize;
		}

	return m_dwDataSize;
}

const DWORD CMediaData::CopyData(const IMediaData *pSrc)
{
	if(!pSrc)return 0UL;

	// f[^̃Rs[
	return SetData(pSrc->GetData(), pSrc->GetSize());
}

IMediaData *CMediaData::Clone(IMediaDataHeap *pHeap) const
{
	// ftHg̎I[o[ChāAK؂Ȍ^ŐKv
	return InternalClone<CMediaData>(pHeap);
}

const DWORD CMediaData::GetBuffer(const DWORD dwGetSize)
{
	if(dwGetSize <= m_dwBuffSize)return m_dwBuffSize;

	// ȂƂwTCYi[łobt@mۂ
	if(!m_pData)
	{
		// obt@mۂ܂
		DWORD dwBuffSize = (dwGetSize > MINBUFSIZE)? dwGetSize : MINBUFSIZE;

		m_pData = m_pHeap->Allocate(dwBuffSize);

		m_dwBuffSize = dwBuffSize;
	}
	else if(dwGetSize > m_dwBuffSize)
	{
		// vTCY̓obt@TCY𒴂
		DWORD dwBuffSize = (dwGetSize > MINBUFSIZE)? dwGetSize : MINBUFSIZE;
		if(dwBuffSize < (dwBuffSize * 2UL))dwBuffSize = dwBuffSize * 2UL;

		BYTE *pNewBuffer = m_pHeap->Allocate(dwBuffSize);

		// f[^Rs[
		if (m_dwDataSize)
		{
			::CopyMemory(pNewBuffer, m_pData, m_dwDataSize);
		}
		
		// obt@J
		if (m_pData != 0)
		{
			m_pHeap->Free(m_pData);
		}

		// obt@ւ
		m_pData = pNewBuffer;
		m_dwBuffSize = dwBuffSize;
	}

	return m_dwBuffSize;
}

const DWORD CMediaData::SetSize(const DWORD dwSetSize)
{
	if(dwSetSize){
		// obt@m
		GetBuffer(dwSetSize);
		}

	// TCYZbg
	m_dwDataSize = dwSetSize;
	
	return m_dwDataSize;
}

const DWORD CMediaData::SetSize(const DWORD dwSetSize, const BYTE byFiller)
{
	// TCYZbg
	SetSize(dwSetSize);
	
	// f[^Zbg
	if(dwSetSize){
		::FillMemory(m_pData, dwSetSize, byFiller);
		}
		
	return m_dwDataSize;
}

void CMediaData::ClearSize(void)
{
	// f[^TCYNA
	m_dwDataSize = 0UL;
}

CMediaData::CMediaData(IBonObject *pOwner, IMediaDataHeap *pHeap)
	: CBonObject()
	, m_dwDataSize(0UL)
	, m_dwBuffSize(0UL)
	, m_pData(0)
	, m_pHeap((pHeap != 0) ? pHeap : &g_DefaultMediaDataHeap)
{
}

CMediaData::CMediaData(const CMediaData &Operand)
	: CBonObject()
	, m_dwDataSize(0UL)
	, m_dwBuffSize(0UL)
	, m_pData(0)
	, m_pHeap(0)
{
	// Rs[RXgN^
	*this = Operand;
}

CMediaData::CMediaData(const BYTE *pData, const DWORD dwDataSize, IMediaDataHeap *pHeap)
	: CBonObject()
	, m_dwDataSize(0UL)
	, m_dwBuffSize(0UL)
	, m_pData(0)
	, m_pHeap((pHeap != 0) ? pHeap : &g_DefaultMediaDataHeap)
{
	// f[^lw肵ăobt@𐶐
	SetData(pData, dwDataSize);
}

CMediaData::~CMediaData(void)
{
	// obt@J
	if (m_pData) m_pHeap->Free(m_pData);
}

CMediaData & CMediaData::operator = (const CMediaData &Operand)
{
	m_pHeap = Operand.m_pHeap;

	// obt@TCY̏܂ł̓Rs[Ȃ
	SetData(Operand.GetData(), Operand.GetSize());

	return *this;
}


/////////////////////////////////////////////////////////////////////////////
// IMediaDecoderNX
/////////////////////////////////////////////////////////////////////////////

const DWORD CMediaDecoder::GetInputNum(void) const
{
	// ͐Ԃ
	return m_dwInputNum;
}

const DWORD CMediaDecoder::GetOutputNum(void) const
{
	// o͐Ԃ
	return m_dwOutputNum;
}

const bool CMediaDecoder::PlayDecoder(void)
{
	DWORD dwOutputIndex;

	// fR[_OtbN
	CBlockLock lock(&m_Lock);

	// ŏɉʃfR[_Đ(͏dv)
	for(dwOutputIndex = 0UL ; dwOutputIndex < GetOutputNum() ; dwOutputIndex++){
		if(m_aOutputDecoder[dwOutputIndex].pDecoder){
			if(!m_aOutputDecoder[dwOutputIndex].pDecoder->PlayDecoder())break;
			}
		}

	// G[͍Đς݃fR[_~
	if(dwOutputIndex < GetOutputNum()){
		while(dwOutputIndex--){
			if(m_aOutputDecoder[dwOutputIndex].pDecoder){
				m_aOutputDecoder[dwOutputIndex].pDecoder->StopDecoder();
				}
			}
		return false;
		}
	
	// ŌɎfR[_Đ
	return OnPlay();
}

const bool CMediaDecoder::StopDecoder(void)
{
	bool bReturn = true;

	// fR[_OtbN
	CBlockLock lock(&m_Lock);

	// ŏɎfR[_~
	if(!OnStop()){
		bReturn = false;
		}

	// ɉʃfR[_~(͏dv)
	for(DWORD dwOutputIndex = 0UL ; dwOutputIndex < GetOutputNum() ; dwOutputIndex++){
		if(m_aOutputDecoder[dwOutputIndex].pDecoder){
			if(!m_aOutputDecoder[dwOutputIndex].pDecoder->StopDecoder()){
				bReturn = false;
				}
			}
		}

	return bReturn;
}

const bool CMediaDecoder::ResetDecoder(void)
{
	bool bReturn = true;

	// fR[_OtbN
	CBlockLock lock(&m_Lock);

	// ŏɉʃfR[_Zbg(͏dv)
	for(DWORD dwOutputIndex = 0UL ; dwOutputIndex < GetOutputNum() ; dwOutputIndex++){
		if(m_aOutputDecoder[dwOutputIndex].pDecoder){
			if(!m_aOutputDecoder[dwOutputIndex].pDecoder->ResetDecoder()){
				bReturn = false;
				}
			}
		}

	// ŌɎfR[_Zbg
	if(!OnReset()){
		bReturn = false;
		}

	return bReturn;
}

const bool CMediaDecoder::SetOutputDecoder(IMediaDecoder *pDecoder, const DWORD dwOutputIndex, const DWORD dwInputIndex)
{
	// fR[_OtbN
	CBlockLock lock(&m_Lock);

	// o̓fR[_Zbg
	if(dwOutputIndex < GetOutputNum()){
		m_aOutputDecoder[dwOutputIndex].pDecoder = pDecoder;
		m_aOutputDecoder[dwOutputIndex].dwInputIndex = dwInputIndex;
		return true;
		}

	return false;
}

const bool CMediaDecoder::InputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex)
{
	if ((pMediaData == 0) || (dwInputIndex >= GetInputNum()))
	{
		return false;
	}
	if (pMediaData->GetSize() == 0)
	{
		return true;
	}

	return OnInputMedia(pMediaData, dwInputIndex);
}

const bool CMediaDecoder::InputMedia(const BYTE *pData, const DWORD dwSize, const DWORD dwInputIndex)
{
	if ((pData == 0) || (dwSize == 0) || (dwInputIndex >= GetInputNum()))
	{
		return false;
	}

	IMediaData *pMediaData = new CMediaData(pData, dwSize, m_pHeap);
	return OnInputMedia(pMediaData, dwInputIndex);
}

const bool CMediaDecoder::OnInputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex)
{
	// InputMedia Ăяo\ȂAI[o[ChĎKv
	BON_ASSERT(false, TEXT("OnInputMedia() must override"));
	return false;
}

CMediaDecoder::CMediaDecoder(IBonObject *pOwner, const DWORD dwInputNum, const DWORD dwOutputNum, IMediaDataHeap *pHeap)
	: CBonObject(pOwner)
	, m_pEventHandler(dynamic_cast<IMediaDecoderHandler *>(pOwner))
	, m_dwInputNum(dwInputNum)
	, m_dwOutputNum(dwOutputNum)
	, m_pHeap(pHeap)
{
	// o̓fR[_zNA
	::ZeroMemory(m_aOutputDecoder, sizeof(m_aOutputDecoder));
}

CMediaDecoder::~CMediaDecoder(void)
{
	BON_SAFE_RELEASE(m_pHeap);
}

const bool CMediaDecoder::OnPlay(void)
{
	// ftHg̎ł͉Ȃ
	return true;
}

const bool CMediaDecoder::OnStop(void)
{
	// ftHg̎ł͉Ȃ
	return true;
}

const bool CMediaDecoder::OnReset(void)
{
	// ftHg̎ł͉Ȃ
	return true;
}

const bool CMediaDecoder::OutputMedia(const IMediaData *pMediaData, const DWORD dwOutptIndex)
{
	// o̓fR[_Ƀf[^n
	if(dwOutptIndex < GetOutputNum()){
		if(m_aOutputDecoder[dwOutptIndex].pDecoder){
			return m_aOutputDecoder[dwOutptIndex].pDecoder->InputMedia(pMediaData, m_aOutputDecoder[dwOutptIndex].dwInputIndex);
			}
		}

	return false;
}

IMediaDataHeap *CMediaDecoder::GetMediaDataHeap() const
{
	return const_cast<IMediaDataHeap *>(m_pHeap);
}

const DWORD CMediaDecoder::SendDecoderEvent(const DWORD dwEventID, const ULONG_PTR param)
{
	// Cxgʒm
	return (m_pEventHandler)? m_pEventHandler->OnDecoderEvent(this, dwEventID, param) : 0UL;
}


/////////////////////////////////////////////////////////////////////////////
// CQueuedMediaDecoderNX
/////////////////////////////////////////////////////////////////////////////

const bool CQueuedMediaDecoder::PlayDecoder(void)
{
	PurgeQueue();

	return CMediaDecoder::PlayDecoder();
}

const bool CQueuedMediaDecoder::StopDecoder(void)
{
	bool result = CMediaDecoder::StopDecoder();
	if (result == false)
	{
		return false;
	}

	PurgeQueue();

	return true;
}

const bool CQueuedMediaDecoder::ResetDecoder(void)
{
	bool result = CMediaDecoder::ResetDecoder();
	if (result == false)
	{
		return false;
	}

	PurgeQueue();

	return true;
}

const bool CQueuedMediaDecoder::InputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex)
{
	if ((pMediaData == 0) || (dwInputIndex >= GetInputNum()))
	{
		return false;
	}
	if (pMediaData->GetSize() == 0)
	{
		return true;
	}

	// I[o[t[ĂȂ
	DWORD newPosition = (m_dwPushPosition + 1) & m_dwMaxQueueItems;
	if ((m_dwPopPosition - newPosition) != 0)
	{
		// MediaData Rs[
		QUEUE_DATA &data = m_pQueueDatas[m_dwPushPosition];
		data.dwInputIndex = dwInputIndex;
		data.pMediaData = pMediaData->Clone(GetMediaDataHeap());

		m_dwPushPosition = newPosition;
		m_Queued.SetEvent();
	}

	return true;
}

const bool CQueuedMediaDecoder::InputMedia(const BYTE *pData, const DWORD dwSize, const DWORD dwInputIndex)
{
	if ((pData == 0) || (dwSize == 0) || (dwInputIndex >= GetInputNum()))
	{
		return false;
	}

	// I[o[t[ĂȂ
	DWORD newPosition = (m_dwPushPosition + 1) & m_dwMaxQueueItems;
	if ((m_dwPopPosition - newPosition) != 0)
	{
		// MediaData Rs[
		QUEUE_DATA &data = m_pQueueDatas[m_dwPushPosition];
		data.dwInputIndex = dwInputIndex;
		data.pMediaData = new CMediaData(pData, dwSize, GetMediaDataHeap());

		m_dwPushPosition = newPosition;
		m_Queued.SetEvent();
	}

	return true;
}

CQueuedMediaDecoder::CQueuedMediaDecoder(IBonObject *pOwner, const DWORD dwInputNum, const DWORD dwOutputNum, const DWORD maxQueueItemBits, IMediaDataHeap *pHeap)
	: CMediaDecoder(pOwner, dwInputNum, dwOutputNum, pHeap)
	, m_dwMaxQueueItems(static_cast<DWORD>(0x01UL << maxQueueItemBits) - 1), m_pQueueDatas(new QUEUE_DATA[0x01 << maxQueueItemBits])
	, m_dwPushPosition(0), m_dwPopPosition(0), m_pDequeueThread(new CSmartThread<CQueuedMediaDecoder>)
{
	m_pDequeueThread->StartThread(TEXT("CQueuedMediaDecoder (Unknown)"), this, &CQueuedMediaDecoder::DequeueThread);
}

CQueuedMediaDecoder::~CQueuedMediaDecoder(void)
{
	m_pDequeueThread->EndThread();

	PurgeQueue();

	delete m_pDequeueThread;
	delete [] m_pQueueDatas;
}

void CQueuedMediaDecoder::SetName(LPCTSTR pName)
{
	m_pDequeueThread->SetThreadName(pName);
}

void CQueuedMediaDecoder::PurgeQueue()
{
	CBlockLock lock(&m_QueueLock);

	m_Queued.ResetEvent();
	while (m_dwPopPosition != m_dwPushPosition)
	{
		QUEUE_DATA &data = m_pQueueDatas[m_dwPopPosition];
		BON_SAFE_RELEASE(data.pMediaData);
		m_dwPopPosition = (m_dwPopPosition + 1) & m_dwMaxQueueItems;
	}
}

void CQueuedMediaDecoder::DequeueThread(CSmartThread<CQueuedMediaDecoder> &thread, const ISignal &bKillSignal, const ULONG_PTR param)
{
	while (true)
	{
		IWaitableObject::WaitResult result =
			(*bKillSignal.GetKernelObject() || m_Queued).Wait();
		if (result != IWaitableObject::Signal1)
		{
			break;
		}

		DWORD counter = m_dwMaxQueueItems >> 8;
		if (counter < 100)
		{
			counter = 100;
		}

		CBlockLock lock(&m_QueueLock);
		while (m_dwPopPosition != m_dwPushPosition)
		{
			QUEUE_DATA &data = m_pQueueDatas[m_dwPopPosition];
			try
			{
				OnInputMedia(data.pMediaData, data.dwInputIndex);
			}
			catch (...)
			{
				BON_SAFE_RELEASE(data.pMediaData);
				throw;
			}
			BON_SAFE_RELEASE(data.pMediaData);
			m_dwPopPosition = (m_dwPopPosition + 1) & m_dwMaxQueueItems;

			// L[̏ԂɍĂȂƁAiɂ甲oȂȂ邽
			// x狭Iɔ
			counter--;
			if (counter == 0)
			{
				break;
			}
		}
	}
}

}
