//////////////////////////////////////////////////////////////////////////
// BonSDK Core engine library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// BonClassEnumerator.cpp: BonNX񋓃NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "BonClassEnumerator.h"
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// BonNX񋓃NX
/////////////////////////////////////////////////////////////////////////////

const DWORD CBonClassEnumerator::EnumBonClass(LPCTSTR lpszBIId)
{
	if(!lpszBIId)return 0UL;
	if(!lpszBIId[0])return 0UL;

	// XgNA
	ReleaseCatalog();

	// C^tF[Xۑ
	::_tcscpy(m_szEnumBIId, lpszBIId);

	// RAGWCX^X擾
	IBonCoreEngine *pCoreEngine = dynamic_cast<IBonCoreEngine *>(::GET_STOCK_INSTANCE(TEXT("CBonCoreEngine")));
	::BON_ASSERT(pCoreEngine != NULL);

	DWORD dwModIndex = 0UL;
	TCHAR szModName[BON_MAX_MODULE_NAME] = TEXT("");
	
	// W[
	while(true){
		const CBonString modName = pCoreEngine->GetBonModuleName(pCoreEngine->EnumBonModule(dwModIndex++));
		if (modName.GetLength() == 0) break;

		// W[J^OCX^X
		IBonModCatalog *pModCatalog = ::BON_SAFE_CREATE<IBonModCatalog *>(modName);

		// Xgɒǉ
		if(pModCatalog)m_CatalogList.push_back(pModCatalog);
		}

	// NX
	for(dwModIndex = 0UL ; dwModIndex < m_CatalogList.size() ; dwModIndex++){
		DWORD dwClassIndex = 0UL;
		
		while(m_CatalogList[dwModIndex]->EnumClass(lpszBIId, dwClassIndex) != BCID_NULL){
			// NXXgɒǉ
			CLASS_CAT_INFO NewInfo = {m_CatalogList[dwModIndex], dwClassIndex++};
			m_ClassList.push_back(NewInfo);
			}
		}

	// w肳ꂽC^tF[X̃NXԂ
	return m_ClassList.size();
}

const DWORD CBonClassEnumerator::GetBonClassNum(void) const
{
	// 񋓂ꂽNXԂ
	return m_ClassList.size();
}

const CBonString CBonClassEnumerator::GetBonModuleName(DWORD dwIndex) const
{
	// W[Ԃ
	CBonString moduleName;
	if (dwIndex < m_ClassList.size()) ::GET_BON_CLASS_NAME(m_ClassList[dwIndex].pModCatalog->GetGuid(), &moduleName);
	return moduleName;
}

const CBonString CBonClassEnumerator::GetBonClassName(DWORD dwIndex) const
{
	// NXԂ
	CBonString className;
	if (dwIndex < m_ClassList.size()) ::GET_BON_CLASS_NAME(m_ClassList[dwIndex].pModCatalog->EnumClass(m_szEnumBIId, m_ClassList[dwIndex].dwClassIndex), &className);
	return className;
}

const CBonString CBonClassEnumerator::GetBonClassDesc(DWORD dwIndex) const
{
	// NX̐Ԃ
	CBonString description;
	if (dwIndex < m_ClassList.size()) description = m_ClassList[dwIndex].pModCatalog->GetClassDesc(m_ClassList[dwIndex].pModCatalog->EnumClass(m_szEnumBIId, m_ClassList[dwIndex].dwClassIndex));
	return description;
}

const CBonString CBonClassEnumerator::GetBonModuleComment(DWORD dwIndex) const
{
	// W[̐Ԃ
	CBonString comment;
	if (dwIndex < m_ClassList.size()) comment = m_ClassList[dwIndex].pModCatalog->GetComment();
	return comment;
}

const CBonString CBonClassEnumerator::GetBonModuleAuthor(DWORD dwIndex) const
{
	// W[̍ҖԂ
	CBonString author;
	if (dwIndex < m_ClassList.size()) author = m_ClassList[dwIndex].pModCatalog->GetAuthor();
	return author;
}

const CBonString CBonClassEnumerator::GetBonModuleWebsite(DWORD dwIndex) const
{
	// W[̘AԂ
	CBonString webSite;
	if (dwIndex < m_ClassList.size()) webSite = m_ClassList[dwIndex].pModCatalog->GetWebsite();
	return webSite;
}

CBonClassEnumerator::CBonClassEnumerator(IBonObject *pOwner)
	: CBonObject(pOwner)
{
	// Ȃ
}

CBonClassEnumerator::~CBonClassEnumerator(void)
{
	// J^OCX^XJ
	ReleaseCatalog();
}

void CBonClassEnumerator::ReleaseCatalog(void)
{
	// C^tF[XNA
	m_szEnumBIId[0] = TEXT('\0');

	// NXXgNA
	m_ClassList.clear();
	
	// J^OCX^XJ
	for(DWORD dwIndex = 0UL ; dwIndex < m_CatalogList.size() ; dwIndex++){
		m_CatalogList[dwIndex]->Release();
		}

	m_CatalogList.clear();
}
