//////////////////////////////////////////////////////////////////////////
// BonSDK Core engine library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// IniCfgStorage.cpp: ėpRtBM[VXg[WNX(INIt@C)
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include <StdLib.h>
#include "TChar.h"
#include "IniCfgStorage.h"


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// ftHg̃ZNV
#define ROOT_SECTNAME		TEXT("General")		// [General]

#define MAX_SECTNAME_LEN	256UL				// őZNV
#define MAX_SECTNAME_NUM	256UL				// őZNV
#define MAX_VALNAME_LEN		256UL				// őACe
#define MAX_VALNAME_NUM		256UL				// őACe
#define MAX_TEXTVAL_LEN		65536UL				// őeLXgACe


/////////////////////////////////////////////////////////////////////////////
// ėpRtBM[VXg[WNX(INIt@C)
/////////////////////////////////////////////////////////////////////////////

const bool CIniCfgStorage::OpenStorage(LPCTSTR lpszPathName, const bool bCreate)
{
	// UN[Y
	CloseStorage();

	// st@C̃pX擾
	TCHAR szFileName[_MAX_PATH + 1] = TEXT("\0");
	TCHAR szDrive[_MAX_DRIVE + 1] = TEXT("\0");
	TCHAR szDir[_MAX_DIR + 1]	  = TEXT("\0");
	TCHAR szFile[_MAX_FNAME + 1]  = TEXT("\0");

	if(!::GetModuleFileName(NULL, szFileName, sizeof(szFileName) - 1))return false;
	::_tsplitpath(szFileName, szDrive, szDir, szFile, NULL);
	::_tmakepath(szFileName, szDrive, szDir, szFile, TEXT("ini"));	

	m_szFileName = szFileName;

	// ZNVݒ
	m_szSectName = (lpszPathName) ? lpszPathName : ROOT_SECTNAME;

	// ZNV݂̑`FbN
	if(!bCreate){
		if(!IsSectionExist(m_szSectName)){
			// ZNVȂ
			CloseStorage();
			return false;
			}
		}

	return true;
}

const bool CIniCfgStorage::CloseStorage(void)
{
	// t@CAZNVNA
	m_szFileName.Clear();
	m_szSectName.Clear();

	return true;
}

IConfigStorage * CIniCfgStorage::OpenSection(LPCTSTR lpszSection, const bool bCreate)
{
	if(m_szFileName.IsEmpty() || !lpszSection)return NULL;

	// ZNV݂̑`FbN
	if(!bCreate){
		// 쐬[hłȂƂ̓ZNVȂ΃G[
		if(!IsSectionExist(lpszSection))return NULL;
		}

	// VCX^X
	CIniCfgStorage *pNewInstance = new CIniCfgStorage(NULL);
	if(!pNewInstance)return NULL;
		
	// t@Cݒ
	pNewInstance->m_szFileName = m_szFileName;

	// VCX^XɃZNVݒ
	pNewInstance->m_szSectName = GetSectionPath(lpszSection);
		
	return pNewInstance;
}

const DWORD CIniCfgStorage::GetSectionNum(void)
{
	if(m_szFileName.IsEmpty())return false;

	// ZNV񋓂
	TCHAR szSections[MAX_SECTNAME_LEN * MAX_SECTNAME_NUM] = TEXT("\0");

	const DWORD dwRet = ::GetPrivateProfileSectionNames(szSections, sizeof(szSections) / sizeof(szSections[0]), m_szFileName);
	if(!dwRet || ((dwRet + 2UL) == (sizeof(szSections) / sizeof(szSections[0]))))return false;

	// ZNVJEg
	DWORD dwSectNum = 0UL;
	LPCTSTR lpszFindPos = szSections;

	while(*lpszFindPos){
		// ZNVCNg
		if(IsSubSectionPath(lpszFindPos))dwSectNum++;
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		}

	return dwSectNum;
}

const CBonString CIniCfgStorage::EnumSection(const DWORD dwIndex)
{
	if(m_szFileName.IsEmpty())return CBonString::GetEmpty();

	// ZNV񋓂
	TCHAR szSections[MAX_SECTNAME_LEN * MAX_SECTNAME_NUM] = TEXT("\0");

	const DWORD dwRet = ::GetPrivateProfileSectionNames(szSections, sizeof(szSections) / sizeof(szSections[0]), m_szFileName);
	if(!dwRet || ((dwRet + 2UL) == (sizeof(szSections) / sizeof(szSections[0]))))return CBonString::GetEmpty();

	// ZNVJEg
	DWORD dwSectNum = 0UL;
	LPCTSTR lpszFindPos = szSections;

	while(*lpszFindPos){
		// ZNVCNg
		if(IsSubSectionPath(lpszFindPos)){
			if(dwSectNum == dwIndex){
				// CfbNXv
				return CBonString(lpszFindPos);
				}

			dwSectNum++;
			}
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		}

	return CBonString::GetEmpty();
}

const bool CIniCfgStorage::DeleteSection(LPCTSTR lpszSection)
{
	if(m_szFileName.IsEmpty() || !lpszSection)return NULL;

	// ZNV݂̑`FbN
	if(!IsSectionExist(lpszSection))return false;

	// ZNVpX
	const CBonString szPath = GetSectionPath(lpszSection);

	// ZNV폜
	return (::WritePrivateProfileSection(szPath, NULL, m_szFileName))? true : false;
}

const DWORD CIniCfgStorage::GetItemNum(void)
{
	if(m_szFileName.IsEmpty())return 0UL;

	// ACe񋓂
	TCHAR szItems[MAX_VALNAME_LEN * MAX_VALNAME_NUM] = TEXT("\0");
	const DWORD dwRet = ::GetPrivateProfileString(m_szSectName, NULL, NULL, szItems, sizeof(szItems) / sizeof(szItems[0]), m_szFileName);

	if(!dwRet || ((dwRet + 2UL) == (sizeof(szItems) / sizeof(szItems[0]))))return 0UL;

	// ACeJEg
	DWORD dwItemNum = 0UL;
	LPCTSTR lpszFindPos = szItems;

	while(*lpszFindPos){
		// ACeCNg
		dwItemNum++;
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		}

	// ACeԂ
	return dwItemNum;
}

const CBonString CIniCfgStorage::EnumItem(const DWORD dwIndex)
{
	if(m_szFileName.IsEmpty())return CBonString::GetEmpty();

	// ACe񋓂
	TCHAR szItems[MAX_VALNAME_LEN * MAX_VALNAME_NUM] = TEXT("\0");
	const DWORD dwRet = ::GetPrivateProfileString(m_szSectName, NULL, NULL, szItems, sizeof(szItems) / sizeof(szItems[0]), m_szFileName);

	if(!dwRet || ((dwRet + 2UL) == (sizeof(szItems) / sizeof(szItems[0]))))return CBonString::GetEmpty();

	// ACeJEg
	DWORD dwItemNum = 0UL;
	LPTSTR lpszFindPos = szItems;

	while(*lpszFindPos){
		// ACeCNg
		if(dwItemNum == dwIndex){
			// CfbNXv
			return CBonString(lpszFindPos);
			}		
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		dwItemNum++;
		}

	return CBonString::GetEmpty();
}

const DWORD CIniCfgStorage::GetItemType(LPCTSTR lpszItem)
{
	if(m_szFileName.IsEmpty() || !lpszItem)return ITEM_TYPE_INVALID;

	// ACe^CvԂ(INIt@C̏ꍇ͏ɃeLXg)
	return (IsItemExist(lpszItem))? ITEM_TYPE_TEXT : ITEM_TYPE_INVALID;
}

const bool CIniCfgStorage::DeleteItem(LPCTSTR lpszItem)
{
	if(m_szFileName.IsEmpty() || !lpszItem)return false;

	// ACe폜
	return (::WritePrivateProfileString(m_szSectName, lpszItem, NULL, m_szFileName))? true : false;
}

const bool CIniCfgStorage::SetBoolItem(LPCTSTR lpszItem, const bool bValue)
{
	if(m_szFileName.IsEmpty() || !lpszItem)return false;
	
	// BOOLZ[u
	return (::WritePrivateProfileString(m_szSectName, lpszItem, (bValue)? TEXT("1") : TEXT("0"), m_szFileName))? true : false;
}

const bool CIniCfgStorage::SetIntItem(LPCTSTR lpszItem, const DWORD dwValue)
{
	if(m_szFileName.IsEmpty() || !lpszItem)return false;

	TCHAR szValue[16];
	::_stprintf(szValue, TEXT("%lu"), dwValue);

	// DWORDZ[u
	return (::WritePrivateProfileString(m_szSectName, lpszItem, szValue, m_szFileName))? true : false;
}

const bool CIniCfgStorage::SetTextItem(LPCTSTR lpszItem, LPCTSTR lpszValue)
{
	if(m_szFileName.IsEmpty() || !lpszItem || !lpszValue)return false;

	// Z[u
	return (::WritePrivateProfileString(m_szSectName, lpszItem, lpszValue, m_szFileName))? true : false;
}

const bool CIniCfgStorage::GetBoolItem(LPCTSTR lpszItem, const bool bDefault)
{
	if(m_szFileName.IsEmpty() || !lpszItem)return bDefault;

	// BOOL[h
	return (::GetPrivateProfileInt(m_szSectName, lpszItem, (bDefault)? 1UL : 0UL, m_szFileName))? true : false;
}

const DWORD CIniCfgStorage::GetIntItem(LPCTSTR lpszItem, const DWORD dwDefault, const DWORD dwMax, const DWORD dwMin)
{
	if(m_szFileName.IsEmpty() || !lpszItem)return dwDefault;

	// DWORD[h
	const DWORD dwValue = (DWORD)::GetPrivateProfileInt(m_szSectName, lpszItem, dwDefault, m_szFileName);
	
	// ͈͂`FbN
	return ((dwValue >= dwMin) && (dwValue <= dwMax))? dwValue : dwDefault;
}

const CBonString CIniCfgStorage::GetTextItem(LPCTSTR lpszItem, LPCTSTR lpszDefault)
{
	if(m_szFileName.IsEmpty() || !lpszItem){
		if (lpszDefault){
			return CBonString(lpszDefault);
			}
		return CBonString::GetEmpty();
		}

	TCHAR szValue[MAX_TEXTVAL_LEN] = TEXT("\0");
	if(lpszDefault)::_tcscpy(szValue, lpszDefault);

	// [h
	const DWORD dwRet = ::GetPrivateProfileString(m_szSectName, lpszItem, (lpszDefault)? lpszDefault : TEXT(""), szValue, sizeof(szValue) / sizeof(szValue[0]), m_szFileName);

	return CBonString(szValue);
}

CIniCfgStorage::CIniCfgStorage(IBonObject *pOwner)
	: CBonObject(pOwner)
{
	m_szFileName.Clear();
	m_szSectName.Clear();
}

CIniCfgStorage::~CIniCfgStorage(void)
{
	// Xg[WN[Y
	CloseStorage();
}

const CBonString CIniCfgStorage::GetSectionPath(LPCTSTR lpszSection) const
{
	if(m_szFileName.IsEmpty() || !lpszSection)::DebugBreak();

	// ZNVpX𐶐
	if(!::_tcscmp(m_szSectName, ROOT_SECTNAME)){
		// [g
		return CBonString(lpszSection);
		}
	else{
		// TuZNVȉ
		return CBonString::Format(TEXT("%1!s!\\%2!s!"), m_szSectName.GetString(), lpszSection);
		}
}

const bool CIniCfgStorage::IsSectionExist(LPCTSTR lpszSection) const
{
	if(m_szFileName.IsEmpty() || !lpszSection)::DebugBreak();

	// ZNV񋓂
	TCHAR szSections[MAX_SECTNAME_LEN * MAX_SECTNAME_NUM] = TEXT("\0");

	const DWORD dwRet = ::GetPrivateProfileSectionNames(szSections, sizeof(szSections) / sizeof(szSections[0]), m_szFileName);
	if(!dwRet || ((dwRet + 2UL) == (sizeof(szSections) / sizeof(szSections[0]))))return false;

	// ZNV
	TCHAR szFindSection[MAX_SECTNAME_NUM];

	if(!::_tcscmp(m_szSectName, ROOT_SECTNAME)){
		// [g
		::_tcscpy(szFindSection, lpszSection);
		}
	else{
		// TuZNVȉ
		::_stprintf(szFindSection, TEXT("%s\\%s"), m_szSectName, lpszSection);
		}

	// ZNV
	LPCTSTR lpszFindPos = szSections;

	while(*lpszFindPos){
		if(!::_tcscmp(lpszFindPos, szFindSection)){
			// ZNVv
			return true;
			}
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		}

	return false;
}

const bool CIniCfgStorage::IsSubSectionPath(LPCTSTR lpszPath) const
{
	if(m_szFileName.IsEmpty() || !lpszPath)::DebugBreak();

	if(!::_tcscmp(m_szSectName, ROOT_SECTNAME)){
		// [g
		if(!::_tcschr(lpszPath, TEXT('\\')))return true;
		}
	else{
		// TuZNVȉ
		const DWORD dwParentLen = ::_tcslen(m_szSectName) + 1UL;

		if((DWORD)::_tcslen(lpszPath) > dwParentLen){
			// eZNV蒷
			if(!::_tcsnicmp(lpszPath, m_szSectName, dwParentLen)){
				// ZNVŎn܂					
				if(!::_tcschr(&lpszPath[dwParentLen], TEXT('\\')))return true;
				}
			}
		}

	return false;
}

const bool CIniCfgStorage::IsItemExist(LPCTSTR lpszItem) const
{
	if(m_szFileName.IsEmpty() || !lpszItem)::DebugBreak();

	// ACe񋓂
	TCHAR szItems[MAX_VALNAME_LEN * MAX_VALNAME_NUM] = TEXT("\0");
	const DWORD dwRet = ::GetPrivateProfileString(m_szSectName, NULL, NULL, szItems, sizeof(szItems) / sizeof(szItems[0]), m_szFileName);

	if(!dwRet || ((dwRet + 2UL) == (sizeof(szItems) / sizeof(szItems[0]))))return false;

	// ACe
	LPCTSTR lpszFindPos = szItems;

	while(*lpszFindPos){
		if(!::_tcsicmp(lpszFindPos, lpszItem))return true;
		
		// ʒuXV
		lpszFindPos += (::_tcslen(lpszFindPos) + 1UL);
		}

	return false;
}
