//////////////////////////////////////////////////////////////////////////
// BonSDK Core engine library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// SmartFile.cpp: ėpt@CXg[WNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "SmartFile.h"
#include <StdIo.h>
#include <Share.h >


/////////////////////////////////////////////////////////////////////////////
// ėpt@CXg[WNX
/////////////////////////////////////////////////////////////////////////////

// ftHg̃obt@TCY
#define DEF_BUFFSIZE	0x100000UL	// 1MB


const bool CSmartFile::Open(LPCTSTR lpszFileName, const DWORD dwModeFlags, const DWORD dwBuffSize)
{
	Close();
	
	TCHAR szOpenMode[16] = {TEXT('\0')};
	int iShareFlags = 0;

	// [h̃`FbN(ǂݏɂ͑ΉĂȂ)
	switch(dwModeFlags){
		case MF_READ :
			::_tcscpy(szOpenMode, TEXT("rb"));
			iShareFlags = _SH_DENYNO;
			break;
			
		case MF_WRITE :
			::_tcscpy(szOpenMode, TEXT("wb"));
			iShareFlags = _SH_DENYWR;		
			break;
		
		default :
			return false;
		}

	// t@CXg[I[v
	if(!(m_pFileStream = ::_tfsopen(lpszFileName, szOpenMode, iShareFlags)))return false;
	
	// obt@TCYݒ
	if(::setvbuf(m_pFileStream, NULL, _IOFBF, (dwBuffSize)? dwBuffSize : DEF_BUFFSIZE)){
		Close();
		return false;
		}

	return true;
}

void CSmartFile::Close(void)
{
	// f[^tbV
	FlushData();
	
	// t@CN[Y
	if(m_pFileStream){
		::fclose(m_pFileStream);
		m_pFileStream = NULL;
		}
}

const DWORD CSmartFile::ReadData(BYTE *pBuff, const DWORD dwLen)
{
	if(!m_pFileStream || !pBuff || !dwLen)return 0UL;
	
	// t@Cǂݎ
	const DWORD dwReturn = ::_fread_nolock(pBuff, 1UL, dwLen, m_pFileStream);
	
	// G[ort@CI[`FbN
	if(dwReturn != dwLen){
		if(::ferror(m_pFileStream)){
			::clearerr(m_pFileStream);
			return 0UL;
			}
		}

	// ǂݎoCgԂ
	return dwReturn;
}

const DWORD CSmartFile::ReadData(BYTE *pBuff, const DWORD dwLen, const ULONGLONG llPos)
{
	// t@C|WVV[N
	if(!SeekPos(llPos))return 0UL;

	// t@Cǂݎ
	return ReadData(pBuff, dwLen);
}

const DWORD CSmartFile::WriteData(const BYTE *pBuff, const DWORD dwLen)
{
	if(!m_pFileStream || !pBuff || !dwLen)return 0UL;

	// t@C
	const DWORD dwReturn = ::_fwrite_nolock(pBuff, 1UL, dwLen, m_pFileStream);

	// G[`FbN
	if(dwReturn != dwLen){
		::clearerr(m_pFileStream);
		return 0UL;
		}

	// 񂾃oCgԂ
	return dwReturn;
}

const DWORD CSmartFile::WriteData(const BYTE *pBuff, const DWORD dwLen, const ULONGLONG llPos)
{
	// t@C|WVV[N
	if(!SeekPos(llPos))return 0UL;

	// t@C
	return WriteData(pBuff, dwLen);
}

const bool CSmartFile::FlushData(void)
{
	if(!m_pFileStream)return false;

	// t@CtbV
	return (!::fflush(m_pFileStream))? true : false;
}

const bool CSmartFile::SeekPos(const ULONGLONG llPos)
{
	if(!m_pFileStream)return false;

	// t@C|WVV[N
	return (!::_fseeki64(m_pFileStream, llPos, SEEK_SET))? true : false;
}

const ULONGLONG CSmartFile::GetPos(void)
{
	if(!m_pFileStream)return 0ULL;

	// t@C|WV擾
	const __int64 iReturn = ::_ftelli64(m_pFileStream);

	return (iReturn != -1LL)? (ULONGLONG)iReturn : 0ULL;
}

const ULONGLONG CSmartFile::GetLength(void)
{
	if(!m_pFileStream)return 0ULL;
	
	// ݂̃t@C|WV擾
	const __int64 iCurPos = ::_ftelli64(m_pFileStream);
	if(iCurPos == -1LL)return 0ULL;

	// t@C|WVI[Ɉړ
	if(::_fseeki64(m_pFileStream, 0LL, SEEK_END))return 0ULL;
	
	// I[̃t@C|WV擾
	const __int64 iEndPos = ::_ftelli64(m_pFileStream);

	// t@C|WVɖ߂
	if(::_fseeki64(m_pFileStream, iCurPos, SEEK_SET))return 0ULL;

	// t@CTCYԂ
	return (iEndPos != -1LL)? (ULONGLONG)iEndPos : 0ULL;
}

CSmartFile::CSmartFile(IBonObject *pOwner)
	: CBonObject(pOwner)
	, m_pFileStream(NULL)
{
	// Ȃ
}

CSmartFile::~CSmartFile(void)
{
	// t@C
	Close();
}
