//////////////////////////////////////////////////////////////////////////
// BonSDK Media decoder library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// TsDescBase.h: fXNv^NX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include <Vector>


/////////////////////////////////////////////////////////////////////////////
// fXNv^ʃC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

class CDescBase :	public CBonObject,
					public IDescBase
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CDescBase)

// IDescBase
	virtual const DWORD ParseDesc(const BYTE *pData, const DWORD dwDataSize);
	virtual const BYTE GetTag(void) const;
	virtual const BYTE GetLength(void) const;
	virtual const BYTE * GetData(void) const;

// CDescBase
	CDescBase(IBonObject *pOwner);
	virtual ~CDescBase(void);

protected:
	virtual const bool ParseData(void);

	BYTE m_byDescTag;
	BYTE m_byDescLen;
	const BYTE *m_pDescData;
};


/////////////////////////////////////////////////////////////////////////////
// fXNv^WC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

class CDescBlock :	public CMediaData,
					public IDescBlock
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CDescBlock)

// IDescBlock
	virtual const DWORD ParseDescs(void);
	virtual void Reset(void);
	virtual const DWORD GetDescNum(void) const;
	virtual const IDescBase * GetDescByTag(const BYTE byTag, const DWORD dwIndex = 0UL) const;
	virtual const IDescBase * GetDescByIndex(const DWORD dwIndex = 0UL) const;
	virtual const bool CopyDescBlock(const IDescBlock *pSrc);

// CMediaData
	virtual const DWORD CopyData(const IMediaData *pSrc);
	virtual IMediaData *Clone(IMediaDataHeap *pHeap) const;

// CPsiSection
	CDescBlock(IBonObject *pOwner, IMediaDataHeap *pHeap = 0);
	virtual ~CDescBlock(void);

protected:
	static CDescBase * CreateDesc(const BYTE byTag);

	std::vector<CDescBase *> m_DescArray;
};
